﻿using Infragistics.Windows.DockManager;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;

namespace XDMCPMenuItems
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        private void ContentPane_OptionsMenuOpening(object sender, Infragistics.Windows.DockManager.Events.PaneOptionsMenuOpeningEventArgs e)
        {
            ContentPane cp = e.OriginalSource as ContentPane;
            //TabGroupPane tgp = this.dch1.Panes[0].Panes[0] as TabGroupPane; // an alternative way to retrieve the TabGroupPane (for the sample's particular hierarchy)
           
            List<object> list = new List<object>();
            foreach (var item in e.Items)
            {
                list.Add(item);
            }

            //When ContentPane is floating - disable "AutoHide"
            if (cp.PaneLocation == PaneLocation.Floating || cp.PaneLocation == PaneLocation.FloatingOnly)
            {
                int autoHideIndex = findItemIndex(list, "Auto Hide");
                if (autoHideIndex != -1)
                {
                    MenuItem autoHideItem = e.Items[autoHideIndex] as MenuItem;
                    autoHideItem.IsEnabled = false;
                }
            }

            // When ContentPane is displayed within DocumentContentHost and there is a single pane within the corresponding TabGroupPane - this is actually not needed
            /*if (cp.PaneLocation == PaneLocation.Document && this.tgp.Items.Count == 1)
            {
                int[] indexes = new int[3];
                indexes[0] = findItemIndex(list, "Close All But This");
                indexes[1] = findItemIndex(list, "New Horizontal Tab Group");
                indexes[2] = findItemIndex(list, "New Vertical Tab Group");

                foreach (int idx in indexes)
                {
                    if (idx != -1)
                    {
                        MenuItem curItem = e.Items[idx] as MenuItem;
                        curItem.IsEnabled = false;
                    }
                }
            }*/
        }

        private int findItemIndex(List<object> items, string header)
        {
            return items.FindIndex(item => item.GetType() == typeof(MenuItem) && (item as MenuItem).Header.Equals(header));
        }

    }
}
